// cc_opt.c for lac
// tab=8spcs

#include "lac.h"


// cc_opt \̂VK쐬
// iq[vjȂ NULL Ԃ
struct cc_opt *CcoptNew (const char *ext, const char *cc, const struct cc_opt *next, int *ml)
// ml: sw̃tO
{
struct cc_opt *ret;
const char *delim = " \t";
const char *ptr;
	// \̂ calloc ŗ̈m
	if ((ret = calloc (sizeof (struct cc_opt), 1)) == NULL) return NULL;

	// ext 𕡐
	if ((ret->ext = strdup (ext)) == NULL) goto ErrorOut;

	// cc ̓ɃtOĂ邩ׂ
	// 2ڈȍ~̓tOƌȂȂ
	while (*cc) {
		if (*cc == '?') {
			if (ret->flag.search) break;
			ret->flag.search = 1;
		}
		else if (*cc == '@') {
			if (ret->flag.uselib) break;
			ret->flag.uselib = 1;
		}
		else if (*cc == '%') {
			if (ret->flag.useopt) break;
			ret->flag.useopt = 1;
		}
		else break;
		cc++;
	}
#ifdef DEBUG
printf ("%s(after checking flag) : %s\n", ext, cc);
#endif

	// ptr  \ ݂̂ȂG[
	ptr = cc;
	ptr += strspn (ptr, delim);
	if (*ptr == '\\' && ptr[1 + strspn (ptr + 1, delim)] == '\0') goto ErrorOut;
#ifdef DEBUG
printf ("ptr(after checking only '\\' in the line) : %s\n", ptr);
#endif

	// ptr ̖ \ Ȃ *ml  1 ԂAȊO 0 Ԃ
	ptr = cc;
	*ml = 0;
	while (*ptr) {
	size_t len;
		ptr += strcspn (ptr, delim);
		len = strspn (ptr, delim);
		if (ptr[len] == '\\' && ptr[len + 1 + strspn (ptr + len + 1, delim)] == '\0') {
			*ml = 1;
			break;
		}
		ptr += len;
#ifdef DEBUG
printf ("ptr(processing...) : %s\n", ptr);
#endif
	}
#ifdef DEBUG
printf ("ptr(after checking '\\' and length) : %s\nlength(ptr - cc) : %d\n", ptr, (size_t)(ptr - cc));
#endif

	// cc 𕡐
//	if ((ret->cc = malloc (ptr - cc + 1)) == NULL) goto ErrorOut;
//	strncpy (ret->cc, cc, ptr - cc)[ptr - cc] = '\0';	// strncpy  n Rs[ '\0' tȂ
	if ((ret->cc = strndup (cc, ptr - cc)) == NULL) goto ErrorOut;

	// next 
	ret->next = (struct cc_opt *)next;

	return ret;

ErrorOut:	// G[I
	CcoptFree (ret);
	return NULL;
}


// cc_opt \̃Xg cc_opt \̃Xg̖ɒǉ
// fvP[g𔺂
// \[gďo͍sȂ
// G[isj NULL Ԃidst ͍XVȂj
struct cc_opt *CcoptCat (struct cc_opt *dst, const struct cc_opt *src)
{
struct cc_opt *ret = dst;

	// dst ̃Xg܂ňړ
	while (dst->next) dst = dst->next;

	// src ̃Xg𕡐Ēǉ
	if ((dst->next = CcoptDup(src)) == NULL) return NULL;

	return ret;
}


// cc_opt \̃Xg cc_opt \̂ nc Xg̖ɒǉ
// fvP[g𔺂
// \[gďo͍sȂ
// G[isj NULL Ԃidst ͍XVȂj
struct cc_opt *CcoptCatnc (struct cc_opt *dst, const struct cc_opt *src)
{
struct cc_opt *ret = dst;

	// dst  nc Xg܂ňړ
	while (dst->nc) dst = dst->nc;

	// src ̃Xg𕡐Ēǉ
	if ((dst->nc = CcoptDup (src)) == NULL) return NULL;

	return ret;
}


// cc_opt \̃XgŜ𕡐
// G[isj NULL Ԃ
struct cc_opt *CcoptDup (const struct cc_opt *old)
{
struct cc_opt *ret = NULL, *tmp, *tmp2 = NULL;
int ml = 0;

	// 
	do {
	struct cc_opt *ncold, *ncnew, *ncprev = NULL;	// nc Np
		tmp = CcoptNew (old->ext, old->cc, 0, &ml);
		// G[炷ׂĔj
		if (tmp == NULL) {
			CcoptFree (ret);
			return NULL;
		}
		if (ret == NULL) ret = tmp;

		tmp->flag = old->flag;

		if (tmp2) tmp2->next = tmp;
		tmp2 = tmp;

		// nc ̃Nǂ
		ncold = old->nc;
		while (ncold) {
			ncnew = CcoptNew (ncold->ext, ncold->cc, 0, &ml);
			// G[炷ׂĔj
			if (ncnew == NULL) {
				CcoptFree (ret);
				return NULL;
			}

			ncnew->flag = ncold->flag;

			if (ncprev) ncprev->nc = ncnew;
			ncprev = ncnew;

			ncold = ncold->nc;
		}
	} while (old = old->next);

	return ret;
}


// cc_opt \̃Xgiׂāj
// vfׂ malloc ŊmۂĂ̂Ɖ肵Ă
void CcoptFree (struct cc_opt *cc_opt)
{
struct cc_opt *tmp;

	while (tmp = cc_opt) {
	struct cc_opt *tmp2 = tmp->nc, *tmp3;
		while (tmp3 = tmp2) {
			tmp2 = tmp3->nc;
			free (tmp3->ext);
			free (tmp3->cc);
			free (tmp3);
		}
		cc_opt = cc_opt->next;
		free (tmp->ext);
		free (tmp->cc);
		free (tmp);
	}
}


// cc_opt \̂ ext ̂T[`inc ͂ǂȂj
// E͓ꎋ
// 0 Ȃ
// 0 i\̂̃AhXj
struct cc_opt *CcoptSearchext (const struct cc_opt *cc_opt, const char *ext)
{
	while (cc_opt) {
		if (stricmp (cc_opt->ext, ext) == 0) break;
		cc_opt = cc_opt->next;
	}
	return (struct cc_opt *)cc_opt;
}
