// cnfdef.c for lac
// tab=8spcs

#include "lac.h"


// cnfdef \̂VK쐬
// G[iNoMemj NULL Ԃ
struct cnfdef *CnfdefNew (const char *h, const struct libs *libs, const struct cnfdef *next)
{
struct cnfdef *ret;

	if ((ret = malloc (sizeof (struct cnfdef))) != NULL) {
		if ((ret->h = strdup (h)) == NULL) {
			free (ret);
			ret = NULL;
		}
		else {
			ret->libs = (struct libs *)libs;
			ret->next = (struct cnfdef *)next;
		}
	}
	return ret;
}


// cnfdef \̃Xg̖ cnfdef \̃Xgǉ
// fvP[g𔺂
// \[gďo͍sȂ
// G[isj NULL Ԃidst ͍XVȂj
struct cnfdef *CnfdefCat (struct cnfdef *dst, const struct cnfdef *src)
{
struct cnfdef *ret = dst;

	while (dst->next) dst = dst->next;
	if ((dst->next = CnfdefDup (src)) == NULL) return NULL;

	return ret;
}


// cnfdef \̃XgŜ𕡐
// G[isj NULL Ԃ
struct cnfdef *CnfdefDup (const struct cnfdef *old)
{
struct cnfdef *ret = NULL, *tmp, *tmp2 = NULL;

	// 
	do {
		tmp = CnfdefNew (old->h, 0, 0);
		if (tmp == NULL) break;
		if (ret == NULL) ret = tmp;

		// 1O next 烊N𒣂
		if (tmp2) tmp2->next = tmp;
		tmp2 = tmp;

		// libs 𕡐
		tmp->libs = LibsDup (old->libs);
		if ((tmp = (struct cnfdef *)tmp->libs) == NULL) break;
	} while (old = old->next);

	// G[炷ׂĔj
	if (tmp == NULL && ret != NULL) {
		CnfdefFree (ret);
		ret = NULL;
	}

	return ret;
}


// cnfdef \̃Xg
// vfׂ malloc Ă̂Ɖ肵Ă
void CnfdefFree (struct cnfdef *cnfdef)
{
struct cnfdef *tmp;

	while (tmp = cnfdef) {
		cnfdef = tmp->next;
		free (tmp->h);
		if (tmp->libs) LibsFree (tmp->libs);
		free (tmp);
	}
}


// cnfdef \̂ h ̂T
// E͓ꎋ
// 0:Ȃ
// 0:icnfdef̃AhXj
struct cnfdef *CnfdefSearchh (const struct cnfdef *cnfdef, const char *h)
{
	while (cnfdef) {
		if (stricmp (cnfdef->h, h) == 0) break;
		cnfdef = cnfdef->next;
	}
	return (struct cnfdef *)cnfdef;
}


