// lac.h for lac
// 4spcs/tab

#ifndef lac_h
#define lac_h

// LIBC 1.1.32A ς cnm ̂S ȍ~
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/dos.h>
#include <sys/xstart_hu.h>

// ϒ variable strings 4.0 ȍ~
#include <vstring.h>

// libmor
#include <mor/stdio.h>
#include <mor/string.h>

// i[p
struct args {
	int sw_l;					// -l (list)     w肳Ă argc ̒l
	int sw_v;					// -v (verbose)  w肳Ă argc ̒l
	int sw_c;					// -c (config)   w肳Ă argc ̒l
	int sw_s;					// -s (source)   w肳Ă argc ̒l
	char *cnf_file;				// config filename
	char *src_file;				// source filename
	char *progname;				// vÕx[X
	struct cc_opt *cc;			// src_fileIꂽcc_opt(nc)Xg
	char execdir[PATH_MAX + 1];	// NfBNg
};

// RtBO
struct config {
	struct cc_opt *cc;	// \[Xgq  RpC̐ݒ
	struct cnfdef *def;	// wb_  Cu̎w
};

// RtBO̊gqR}hXg
struct cc_opt {
	char	*ext;				// gq
	char	*cc;				// RpC̃R}h{IvV
	struct {					// tOirbgtB[hj
		unsigned int search:1;	// \[X邩
		unsigned int uselib:1;	// ʂ̃CuR}hɓn
		unsigned int useopt:1;	// R}hC compiler options g
	} flag;
	struct cc_opt *nc;			// ̃R}h 0ȂIisɓnw肪鎞Ɏgpj
	struct cc_opt *next;		//  0ȂIinc ŃNĂvfł͕K 0j
};

// RtBÕwb_CuXg
struct cnfdef {
	char	*h;				// wb_t@C
	struct libs *libs;		// Cu
	struct cnfdef *next;	//  0ȂI
};

// Cut@CXg
struct libs {
	char	*lib;		// Cut@C
	struct libs *next;	//  0ȂI
};


// IR[hm肵Ă̂ Usage = 1 炢ŁA͏ɕtĂł
// Undef  127*128 + xxx ܂Ăƌ΂c
#define Usage				1
#define Sw_c				2
#define Src_file			3
#define CnfNotFound			4
#define NoMem				5
#define FileAcsFault		6
#define CnfFormatError		7
#define NoExtInCnf			8
#define SrcNotFound			9
#define SrcSyntax			10
#define MisCallCC			11
#define CallCC_MisGetToken	12
#define SetCCOpt_Ml_RetCC	13
#define ErrorMax			255		// G[R[hőliUndef n͏j
#define Undef			(127<<8)	// `̃G[iȂRj

// G[bZ[W\ďI
extern volatile void Error (int code);

// cc_opt \̂VK쐬
extern struct cc_opt *CcoptNew (const char *, const char *, const struct cc_opt *, int *);
// cc_opt \̃Xg𑼂 cc_opt \̃Xgɒǉ
extern struct cc_opt *CcoptCat (struct cc_opt *, const struct cc_opt *);
// cc_opt \̃Xg cc_opt \̂ nc Xg̖ɒǉ
extern struct cc_opt *CcoptCatnc (struct cc_opt *, const struct cc_opt *);
// cc_opt \̃XgŜ𕡐
extern struct cc_opt *CcoptDup (const struct cc_opt *);
// cc_opt \̃Xg
extern void CcoptFree (struct cc_opt *);
// cc_opt \̂ ext ̂T
extern struct cc_opt *CcoptSearchext (const struct cc_opt *, const char *);

// cnfdef \̂VK쐬
extern struct cnfdef *CnfdefNew (const char *, const struct libs *, const struct cnfdef *);
// cnfdef \̃Xg̖ cnfdef \̃Xgǉ
extern struct cnfdef *CnfdefCat (struct cnfdef *, const struct cnfdef *);
// cnfdef \̃XgŜ𕡐
extern struct cnfdef *CnfdefDup (const struct cnfdef *);
// cnfdef \̃Xg
extern void CnfdefFree (struct cnfdef *);
// cnfdef \̂ h ̂T
extern struct cnfdef *CnfdefSearchh (const struct cnfdef *, const char *);

// libs \̃XgVK쐬
extern struct libs *LibsNew (const char *);
// libs \̃Xg̖ libs \̃Xgǉ
extern struct libs *LibsCat (struct libs *, const struct libs *);
// libs \̃Xg𕡐
extern struct libs *LibsDup (const struct libs *);
// libs \̃Xg
extern void LibsFree (struct libs *);
// libs \̃Xg瓯Cu
extern void LibsShrink (struct libs *);
// libs \̃Xg string ̗vfijVKɒǉ
extern struct libs *LibsAddstring (struct libs *, const char *);

#endif

// End of file.