// libs.c for lac
// tab=8spcs

#include "lac.h"


// libs \̃XgVK쐬
// buf if~^ƃk̕ĵƂ̗͋vfԂ
struct libs *LibsNew (const char *buf)
// buf:	if~^ Space  H-Tabj
// ߂l: CũXgiNULL ̓G[iNoMemjj
{
struct libs *ret, *tmp;
char *token, *buf2, *delim = " \t";

	// Ɨp buf ̕
	buf2 = strdup (buf);
	if (buf2 == NULL) return NULL;

	// ŏ̃t@C
	if ((ret = malloc (sizeof (struct libs))) == NULL) goto free_quit;
	ret->next = 0;
	if ((token = strtok (buf2, delim)) == NULL) {
		// ̕񂾂k݂̂̕ZbgďI
		if ((ret->lib = strdup ("")) == NULL) {
			free (ret);
			ret = NULL;
		}
		goto free_quit;
	}
	if ((ret->lib = strdup (token)) == NULL) {
		free (ret);
		ret = NULL;
		goto free_quit;
	}

	// 2t@Cڈȍ~
	tmp = ret;
	while (token = strtok (NULL, delim)) {
		tmp->next = malloc (sizeof (struct libs));
		if (tmp->next == NULL) {
			LibsFree (ret);
			ret = NULL;
			goto free_quit;
		}
		tmp = tmp->next;
		tmp->lib = strdup (token);
		if (tmp->lib == NULL) {
			LibsFree (ret);
			ret = NULL;
			goto free_quit;
		}
		tmp->next = 0;
	}

free_quit:
	free (buf2);

	// N̐擪Ԃ
	return ret;
}


// libs \̃Xg̖ libs \̃Xgǉ
// fvP[g
// e̔r\[gEd͂Ȃ
// dst  NULL ̎ LibsDup (src) Ɠ
// G[ NULL Ԃ
struct libs *LibsCat (struct libs *dst, const struct libs *src)
{
struct libs *ret, *tmp;

	if ((tmp = LibsDup (src)) == NULL) return NULL;
	if (dst) {
		ret = dst;
		while (dst->next) dst = dst->next;
		dst->next = tmp;
	}
	else ret = tmp;

	return ret;
}


// libs \̃Xg𕡐
// G[ NULL Ԃ
struct libs *LibsDup (const struct libs *old)
{
struct libs *ret = NULL, *tmp, *tmp2 = NULL;

	// 
	do {
		tmp = LibsNew (old->lib);
		if (tmp == NULL) break;
		if (ret == NULL) ret = tmp;

		// 1O next 烊N𒣂
		if (tmp2) tmp2->next = tmp;
		tmp2 = tmp;
	} while (old = old->next);

	// G[炷ׂĔj
	if (tmp == NULL && ret != NULL) {
		LibsFree (ret);
		ret = NULL;
	}

	return ret;
}


// libs \̃Xg
// vfׂ malloc ŊmۂĂ̂Ɖ肵Ă
void LibsFree (struct libs *libs)
{
struct libs *tmp;

	while (tmp = libs) {
		libs = libs->next;
		free (tmp->lib);
		free (tmp);
	}
}


// libs \̃Xg瓯Cu
// vfׂ͂ malloc ŊmۂĂ̂Ɖ肵Ă
void LibsShrink (struct libs *libs)
{
struct libs *prev, *tmp;

	while (libs) {
		prev = libs;
		tmp = libs->next;

		// CuT
		while (tmp) {
			if (stricmp (libs->lib, tmp->lib) == 0) {
				prev->next = tmp->next;
				tmp->next = 0;
				LibsFree (tmp);
			}
			else prev = tmp;
			tmp = prev->next;
		}
		libs = libs->next;
	}
}


// libs \̃Xg string ̗vfijVKɒǉ
// G[ NULL Ԃ
struct libs *LibsAddstring (struct libs *libs, const char *string)
{
struct libs *tmp;

	if ((tmp = LibsNew (string)) == NULL) return NULL;

	if ((libs = LibsCat (libs, tmp)) == NULL) LibsFree (tmp);

	return libs;
}


